﻿// concat … ファイルのコピー 

#include <fstream>
#include <iostream>

using namespace std;

//--- srcからの入力をdstへ出力 ---//
void copy(istream& src, ostream& dst)
{
	char ch;

	src >> noskipws;
	while (src >> ch)
		dst << ch;
}

int main(int argc, char** argv)
{
	ifstream is;

	if (argc < 2)
		copy(cin, cout);			// 標準入力を標準出力にコピー
	else {
		while (--argc > 0) {
			ifstream fs(*++argv);
			if (!fs)
				cerr << "\aファイル" << *argv << "をオープンできません。\n";
			else
				copy(fs, cout);		// ストリームfsを標準出力にコピー
		}
	}
}
