// xNgɑ΂ASY̓Kp

#include <string>
#include <vector>
#include <iostream>
#include <algorithm>
#include <functional>

using namespace std;

//=== lɑăXy[XPo ===//
template <class Type>
struct put1 : public unary_function<const Type&, void> {
	void operator()(const Type& n) {
		cout << n << ' ';				// Xy[XP
	}
};

//=== lɑăXy[XPóicharpɓꉻj===//
template <>
struct put1<char>: public unary_function<const char&, void> {
	void operator()(const char& n) {
		cout << "'" << n << "' ";		// Ppň͂ŃXy[XP
	}
};

//=== lɑăXy[XPóistd::stringpɓꉻj===//
template <>
struct put1<std::string>: public unary_function<const std::string&, void> {
	void operator()(const std::string& n) {
		cout << "\"" << n << "\" ";		// dpň͂ŃXy[XP
	}
};

//--- [first, last)̑SvfXy[XPŋ؂{}ň͂ŏɕ\ ---//
template<class InputIterator>
void print(InputIterator first, InputIterator last)
{
	cout << "{ ";
	for_each(first, last, put1<std::iterator_traits<InputIterator>::value_type>());
	cout << "}";
}

//--- ł邩ǂ߂ ---//
template <class Type>
struct is_even : public unary_function<const Type&, bool> {
	bool operator()(const Type& n) {
		return n % 2 == 0;
	}
};

//--- 10l߂ ---//
template <class Type>
struct plus10 : public unary_function<const Type&, const Type&> {
	Type operator()(const Type& n) {
		return n + 10;
	}
};

//--- ߂ ---//
template <class Type>
struct diff : public binary_function<const Type&, const Type&, Type> {
	Type operator()(const Type& a1, const Type& a2) {
		return (a1 < a2) ? a2 - a1 : a1 - a2;
	}
};

int main()
{
	vector<int> a;
	for (vector<int>::size_type i = 0; i < 10; i++)
		a.push_back(i);

	vector<int> b(a);						// ãRs[
	random_shuffle(b.begin(), b.end());		// Vbt

	vector<bool> c(10);		// ȃSvfǂ
	transform(a.begin(), a.end(), c.begin(), is_even<int>());

	vector<int> d(10);		// ȃSvf10xNg
	transform(a.begin(), a.end(), d.begin(), plus10<int>());

	vector<int> e(10);		// ab̊evf̍i[xNg
	transform(a.begin(), a.end(), b.begin(), e.begin(), diff<int>());

	cout << "a = ";   print(a.begin(), a.end());   cout << '\n';
	cout << "b = ";   print(b.begin(), b.end());   cout << '\n';
	cout << "c = ";   print(c.begin(), c.end());   cout << '\n';
	cout << "d = ";   print(d.begin(), d.end());   cout << '\n';
	cout << "e = ";   print(e.begin(), e.end());   cout << '\n';
}
